%define maj 1
%define min 0
%define rel 7

Summary:     A logical volume manager for linux
Name:        lvm
Version:     %{maj}.%{min}.%{rel}
Release:     7.pp
License:     GPL
Group:       Console/Drivers
Source0:     ftp://ftp.sistina.com/pub/LVM/%{maj}.%{min}/lvm_%{version}.tar.gz
Source1:     sysinit-lvm.patch
URL:         http://www.sistina.com/lvm/
Buildroot:   /var/tmp/lvm-root
Vendor:      Peter Pramberger
Packager:    Peter Pramberger <peter.pramberger@1012surf.net>
Requires:    kernel >= 2.4
Provides:    lvm.pp
Prereq:      /bin/bash /bin/grep /bin/sed
BuildPrereq: gcc >= 2.96 /bin/mkdir /usr/bin/make /usr/bin/install
ExclusiveOS: linux

%description
The Logical Volume Manager (LVM) is a subsystem for online
disk storage management which has become a de facto standard
for storage management under Linux.


%package ro_root
Group:       Console/Drivers
Summary:     The LVM tools for readonly root (writes to /tmp)
Requires:    lvm = %{version}-%{release} lvm.pp
Provides:    lvm-ro_root.pp

%description ro_root
This package contains the patched LVM tools for use on a readonly
root filesystem where /etc is not writable (at least at boot).
Therefore this modified tools write the config to /tmp (eg. tmpfs).


%prep
%setup -q -n LVM
cd %{version}
cp $RPM_SOURCE_DIR/sysinit-lvm.patch .
# Workaround, see ChangeLog
cp -f tools/Makefile.in tmpfile
sed -e 's+-llvm-@iop_ver@+lib/liblvm-@iop_ver@.a+g' tmpfile > tools/Makefile.in
rm -f tmpfile


%build
cd %{version}
export CFLAGS="$RPM_OPT_FLAGS"
./configure --prefix=/usr --sbindir=/sbin    \
	--sysconfdir=/etc --with-user=root   \
	--with-kernel_dir=/usr/src/linux-2.4 \
	--with-group=root #--enable-static_link   # Workaround, see ChangeLog
make


%define __os_install_post /usr/lib/rpm/brp-compress


%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/sbin
mkdir -p $RPM_BUILD_ROOT/usr
cd %{version}
make prefix=$RPM_BUILD_ROOT/usr sbindir=$RPM_BUILD_ROOT/sbin install


%post
if ! /bin/grep "/sbin/vgscan" /etc/rc.sysinit > /dev/null 2>&1; then
   echo "Please install the following patch before reboot!"
   echo "cd /; patch -p1 -E < /usr/doc/lvm-%{version}/sysinit-lvm.patch"
fi

%post ro_root
for file in `ls /sbin/{e2fsadm*,lv*,pv*,vg*}`; do
   cp -f ${file} /tmp/tmp_file
   sed -e "s:/etc/lvm:/tmp/lvm:g" /tmp/tmp_file > ${file}
   rm -f /tmp/tmp_file
done


%preun ro_root
for file in `ls /sbin/{e2fsadm*,lv*,pv*,vg*}`; do
   cp -f ${file} /tmp/tmp_file
   sed -e "s:/tmp/lvm:/etc/lvm:g" /tmp/tmp_file > ${file}
   rm -f /tmp/tmp_file
done


%clean
rm -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,root)
%doc %{version}/ABSTRACT %{version}/CHANGELOG %{version}/CONTRIBUTORS
%doc %{version}/COPYING* %{version}/FAQ %{version}/INSTALL
%doc %{version}/KNOWN_BUGS %{version}/LVM-HOWTO %{version}/README
%doc %{version}/TODO %{version}/WHATSNEW %{version}/sysinit-lvm.patch
/sbin/*
/usr/lib/*
/usr/man/man8/*

%files ro_root
%defattr(-,root,root)


%changelog
* Wed May 07 2003 peter.pramberger@1012surf.net
- new version 1.0.7

* Mon Sep 23 2002 peter.pramberger@1012surf.net
- Do not link static -> vgscan gives segfault
  somewhere at atexit (at least with GLIBC 2.2.5)
- Link static only against liblvm, GLIBC dynamic

* Wed Sep 18 2002 peter.pramberger@1012surf.net
- new version 1.0.5
- added package with patched tools for ro root

* Wed Jul 04 2002 peter.pramberger@1012surf.net
- new version 1.0.4

* Tue Jan 22 2002 peter.pramberger@1012surf.net
- final version 1.0.1

* Tue Sep 25 2001 thomas.holzgruber@1012surf.net
- new version 1.0.1-rc2

* Fri Jun 29 2001 peter.pramberger@1012surf.net
- created

